'use strict';

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.consoleReplay = consoleReplay;
exports.default = buildConsoleReplay;

var _RenderUtils = require('./RenderUtils');

var _RenderUtils2 = _interopRequireDefault(_RenderUtils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function consoleReplay() {
  // console.history is a global polyfill used in server rendering.
  var history = console.history;
  if (!history || history.length === 0) {
    return '';
  }

  var lines = history.map(function (msg) {
    var stringifiedList = msg.arguments.map(function (arg) {
      try {
        return typeof arg === 'string' || arg instanceof String ? arg : (0, _stringify2.default)(arg);
      } catch (e) {
        return e.message + ': ' + arg;
      }
    });

    return 'console.' + msg.level + '.apply(console, ' + (0, _stringify2.default)(stringifiedList) + ');';
  });

  return lines.join('\n');
}

function buildConsoleReplay() {
  return _RenderUtils2.default.wrapInScriptTags(consoleReplay());
}